<?php
/*$Id: nc_subscriber.class.php 3862 2010-08-06 13:04:53Z denis $*/
/**
*    
*   
*
*/
class nc_subscriber {
  protected $core, $db;    // nc_core  db
  protected $period_table; //  
  protected $_mailer;      //   
  protected $_subscribers; //    
  
  public $tools;           //    


  /**
   * 
   */
  protected function __construct () {
    //   
    $this->core = nc_Core::get_object();
    $this->db =  $this->core->db;
    $this->tools = nc_subscriber_tools::get_object();

    //    
    $this->period_table = 'SubscriberPeriod';
    //     
    $this->_mailer = array();
    $this->_subscribers = array();

    // 
    $this->core->event->bind( $this, array("addMessage" => "add_message") );
    $this->core->event->bind( $this, array("updateMessage" => "update_message") );
    $this->core->event->bind( $this, array("dropMessage" => "drop_message") );
    $this->core->event->bind( $this, array("dropSubClass" => "drop_sub_class") );
    $this->core->event->bind( $this, array("dropUser" => "drop_user") );
  }


  /**
   * Get or instance self object
   *
   * @example $nc_subscriber = nc_subscriber::get_object();
   * @return nc_subscriber object
   */
  public static function get_object () {
    // call as static
    static $storage;
    // check inited object
    if ( !isset($storage) ) {
      // init object
      $storage = new self();
    }
    // return object
    return is_object($storage) ? $storage : false;
  }
  

  /**
   *    
   * @param int cc    
   * @param int message  
   * @param int rel_cc   
   * @param int rel_message ,      ,    
   *  cc - message
   */
  public function new_message ( $cc, $message, $rel_cc = 0, $rel_message = 0 ) {
    // 
    $cc = intval($cc);
    $message = intval($message);
    $rel_cc = intval($rel_cc);
    $rel_message = intval($rel_message);

    if ( !$cc || !$message ) {
      throw new ExceptionParam(__CLASS__.'::'.__FUNCTION__);
    }


    $this->db->last_error = '';
    $this->db->query("INSERT INTO `Subscriber_Message`(`Sub_Class_ID`, `Message_ID`, `Rel_Sub_Class_ID`, `Rel_Message_ID`)
                      VALUES('".$cc."', '".$message."', '".$rel_cc."', '".$rel_message."') ");
    if ( $this->db->last_error ) {
      throw new ExceptionDB(__CLASS__.'::'.__FUNCTION__);
    }

    return 0;
  }


  /**
   *    .   .
   *     -  
   * 
   * @global int $AUTH_USER_ID
   * @param int $mailer_id  
   * @param int $user_id  . 0 -  .     -  
   * @param int $period -  ,  false -    
   * @param string $status -  (on, off, wait).  false -   
   * @param array $fields -     array('Email'=>$email; 'Name'=> $name)
   * @param int $message -  ,    
   *
   * @return <mixed> false - .   -  
   */
  public function subscription_add ( $mailer_id, $user_id = 0, $period = 0, $status = false, $fields = array(), $message = 0 ) {
    //    
    $mailer = $this->get($mailer_id);
    //  
    $message = intval($message);
    //  
    $user_id = intval($user_id);
    //   
    if ( !$user_id ) {
      global $AUTH_USER_ID;
      $user_id = intval($AUTH_USER_ID);
    } 
    //   .    
    if ( !$user_id) {
      //     ,    - ,   
      if ( $mailer['Access'] > 1 || !$this->core->modules->get_by_keyword('auth')) {
        throw new Exception (NETCAT_MODERATION_ERROR_NORIGHT);
      }
      //  
      $email = $fields[$this->tools->get_settings('EmailField')];
      if ( !$email || !preg_match ("/^[a-z0-9\._-]+@[a-z0-9\._-]+\.[a-z]{2,4}\$/i", $email) ) {
        throw new ExceptionEmail ();
      }
      $nc_auth = nc_auth::get_object();
      //   
      $control_sub = $this->tools->get_subscribe_sub('Subdivision_ID');
      //  
      $user = $nc_auth->hash->add_pseudo_user( $fields, $control_sub );
      //   
      $user_id = $user['User_ID'];

    }
    //  
    $this->tools->check_user($user_id);

    //              (    )
    $sbs_exist =  $this->db->get_var("SELECT `ID` FROM `Subscriber_Subscription` WHERE `User_ID` = '".$user_id."' AND `Mailer_ID` = '".$mailer_id."' "); 
    if ( $sbs_exist && ($mailer['Type'] != 1 || !$message) ) {
      throw new Exception(NETCAT_MODULE_SUBSCRIBER_ALREADY_SUBSCRIBE);
    }


    if ( $mailer['Type'] == 1 && $message ) {
      $msbs_exist = $this->db->get_var("SELECT `ID` FROM `Subscriber_UserMessage`
                                       WHERE `Mailer_ID` = '".$mailer_id."'
                                       AND `Message_ID` = '".$message."'
                                       AND `User_ID` = '".$user_id."'"); 
      if ( $msbs_exist  ) {
        throw new Exception(NETCAT_MODULE_SUBSCRIBER_ALREADY_SUBSCRIBE);
      }
      $this->db->query("INSERT INTO `Subscriber_UserMessage`(`User_ID`, `Sub_Class_ID`, `Message_ID`, `Mailer_ID`)
                        VALUES ('".$user_id."','".$mailer['Sub_Class_ID']."','".$message."', '".$mailer_id."')");
      if ( $sbs_exist ) return "on";
    }

      
    //  period
    $period = intval($period);
    if ( $period ) {
      $this->tools->check_period($period);
    }
    else { //   
      $period = $this->tools->get_default_period();
    }

    //  
    if ( $status ) {
      if ( !in_array($status, array('on', 'off', 'wait'))) {
        throw new ExceptionParam(__CLASS__.'::'.__FUNCTION__, 'status');
      }
    }
    else {
      $status = $this->tools->get_default_status($user_id);
    }

    //     /  
    $link = md5( rand(0,100).$status."NetCat".time().$user_id).$user_id."-".$mailer['Mailer_ID'];
    $link = $this->db->escape($link);

    // ,  
    $this->db->last_error = '';
    $this->db->insert_id = 0;

    $this->db->query("INSERT INTO `Subscriber_Subscription`(`User_ID`, `Mailer_ID`, `Period`, `Status`, `Hash`, `Created`)
                VALUES ('".$user_id."','".$mailer['Mailer_ID']."','".$period."','".$status."', '".$link."', \"".date("Y-m-d H:i:0")."\")");
    //    sql -  
    if ( $this->db->last_error ) {
      throw new ExceptionDB(__CLASS__.'::'.__FUNCTION__);
    }

    $subscr_id = $this->db->insert_id;
    if ( !$subscr_id ) return false;
    
    //    
    if ( $status == 'wait' ) {
      $this->send_confirm_mail($mailer['Mailer_ID'], $user_id, $link);
    }
    //   
    $this->tools->log ( $mailer['Mailer_ID'], $user_id, 'subscribe');

    return  $status;
  }

  /**
   *    ,         cc
   *    subscription_add
   * @param int $cc  
   * @param int $user_id  
   * @param int $period 
   * @param int $status 
   * @param array $fields   
   * @return mixed false - .   -  
   */
  public function subscription_add_by_cc ($cc, $user_id = 0, $period = 0, $status = false, $fields = array(), $message = 0) {
    //  
    $this->tools->check_cc($cc);

    $mailer = $this->get_mailer_by_cc($cc);
    return $this->subscription_add($mailer['Mailer_ID'], $user_id, $period, $status, $fields, $message);
    
  }

  /**
   *   " ".
   *     - ,     
   * @param int $catalogue
   * @param int $sub
   * @param int $cc
   * @param int $class
   * @param mixed $message
   */
  public function add_message ( $catalogue, $sub, $cc, $class, $message ) {
    $db = $this->db;
    //    -    
    if ( is_array($message) ) {
      if ( !empty($message) )
      foreach ( $message as $v) {
        $this->add_message($catalogue, $sub, $cc, $class, $v);
      }

      return 0;
    }

    $cc = intval($cc);
    $class = intval($class);
    $message = intval($message);

    if ( !$cc || !$class || !$message ) {
      return false;
    }

    //     ,    
    $action_type = $db->get_var("SELECT `ActionType`
                                 FROM `Subscriber_Mailer` AS `sm`,
                                      `Subscriber_Subscription` AS `ss`
                                 WHERE sm.`Sub_Class_ID` = '".$cc."'
                                 AND `Active` = '1'
                                 AND `Type` = '1' 
                                 AND ss.`Mailer_ID` = sm.`Mailer_ID` 
                                 AND ss.`Status` = 'on' ");
    //    ActionType - 1,   " "
    //    ActionType - 1,   " "
    if ( $action_type ) {
      //  / ?
      $checked = $db->get_var("SELECT `Checked`
                               FROM `Message".$class."`
                               WHERE `Message_ID` = '".$message."'");

      if ( ($checked && $action_type & 1) || (!$checked && $action_type & 2) ) {
        // , 
        $this->new_message($cc, $message);
      }
    
    }

    return 0;
  }



  /**
   *   " ".
   *     - ,     
   * @param int $catalogue
   * @param int $sub
   * @param int $cc
   * @param int $class
   * @param mixed $message
   */
  public function update_message ( $catalogue, $sub, $cc, $class, $message ) {
    $db = $this->db;
    //    -    
    if ( is_array($message) ) {
      if ( !empty($message) )
      foreach ( $message as $v) {
        $this->add_message($catalogue, $sub, $cc, $class, $v);
      }

      return 0;
    }

    $cc = intval($cc);
    $class = intval($class);
    $message = intval($message);

    if ( !$cc || !$class || !$message ) {
      return false;
    }

    //     ,    
    $action_type = $db->get_var("SELECT `ActionType`
                                 FROM `Subscriber_Mailer` AS `sm`,
                                      `Subscriber_Subscription` AS `ss`
                                 WHERE sm.`Sub_Class_ID` = '".$cc."'
                                 AND `Active` = '1'
                                 AND `Type` = '1'
                                 AND ss.`Mailer_ID` = sm.`Mailer_ID`
                                 AND ss.`Status` = 'on' ");

    if ( $action_type ) {
      // 4 -  , 16 - 
      //8 -  , 32 - 
      //  / ?
      $checked = $db->get_var("SELECT `Checked`
                               FROM `Message".$class."`
                               WHERE `Message_ID` = '".$message."'");

      if (   ( $checked &&  ($action_type & 4 || $action_type & 16) )
           || (!$checked && ($action_type & 8 || $action_type & 32) ) ) {
        // , 
        $this->new_message($cc, $message);
      }

    }

    return 0;
  }


  /**
   *    
   * @param int $catalogue
   * @param int $sub
   * @param int $cc
   * @param int $class
   * @param array $message
   * @return
   */
  public function drop_message ( $catalogue, $sub, $cc, $class, $message ) {
    if ( !is_array($message) ) $message = array($message);
    $cc = intval($cc);
    
    if ( !$cc || empty($message) ) 
      return 0;

    $this->db->query("DELETE FROM `Subscriber_Message`
                      WHERE 
                     (`Sub_Class_ID` = '".$cc."'
                      AND `Message_ID` IN (".join(', ', $message).") )
                     OR (`Rel_Sub_Class_ID` = '".$cc."'
                     AND `Rel_Message_ID` IN (".join(', ', $message).") ) ");

   $this->db->query("DELETE FROM `Subscriber_UserMessage`
                      WHERE
                     `Sub_Class_ID` = '".$cc."'
                      AND `Message_ID` IN (".join(', ', $message).")  ");

    return 0;
  }


  public function drop_sub_class ( $catalogue, $sub, $cc ) {
    if ( !is_array($cc) ) $cc = array($cc);


    if ( empty($cc) )
      return false;

    $this->db->query("DELETE FROM `Subscriber_Message`
                      WHERE `Sub_Class_ID` IN (".join(', ', $cc).") OR `Rel_Sub_Class_ID` IN (".join(', ', $cc).") ");

    $this->db->query("DELETE FROM `Subscriber_UserMessage`
                      WHERE `Sub_Class_ID` IN (".join(', ', $cc).")  ");

    $mailers_id = $this->db->get_col("SELECT `Mailer_ID` FROM `Subscriber_Mailer`
                      WHERE `Sub_Class_ID`IN (".join(', ', $cc).")  AND `Type` = '1' ");

    if ( !empty($mailers_id) ) {
      $this->delete($mailer_ids);
    }


  }


  public function drop_user ( $user_ids ) {
    if ( !is_array($user_ids)) $user_ids = array($user_ids);

    $this->db->query("DELETE FROM `Subscriber_Log` WHERE `User_ID` IN (".join(',', $user_ids).")");
    $this->db->query("DELETE FROM `Subscriber_Subscription` WHERE `User_ID` IN (".join(',', $user_ids).")");
    $this->db->query("DELETE FROM `Subscriber_UserMessage` WHERE `User_ID` IN (".join(',', $user_ids).")");

    if ( $this->core->modules->get_by_keyword('auth') ) {
      $nc_auth = nc_auth::get_object();
      $c_sub = $this->tools->get_subscribe_sub('Subdivision_ID');
      $users = $this->db->get_results("SELECT `User_ID`, `UserType` FROM `User` WHERE `User_ID` IN (".join(',', $user_ids).")", ARRAY_A);

      if ( !empty($users) ) {
        foreach ( $users as $v ) {
          if ( $v['UserType'] == 'pseudo'  ) {
            $nc_auth->hash->delete_from_sub($c_sub , $v['User_ID']);
          }
        }
      }
    }
  }

  /**
   *       ,    
   * @param int $cc    
   * @param string $item  
   * @return mixed     
   */
  public function get_mailer_by_cc ( $cc, $item = '' ) {
    //  
    $cc = intval($cc);
    if ( !$cc ) {
      throw new  ExceptionParam( __CLASS__.'::'.__FUNCTION__, 'cc');
    }
    //       
    $mailer_id = 0;
    if ( !empty($this->_mailer) ) {
      foreach ( $this->_mailer as $v ) {
        if ( $v['Type'] == 1 && $v['Suv_Class_ID'] == $cc) {
          $mailer_id = $v['Mailer_ID'];
        }
      }
    }
    //     -    
    if ( !$mailer_id ) {
      $mailer_temp = $this->db->get_row("SELECT * FROM `Subscriber_Mailer`
                        WHERE `Sub_Class_ID` = '".$cc."' AND `Type` = '1'", ARRAY_A); 
      //    -    
      if ( empty($mailer_temp) ) {
        throw new ExceptionMailer();
      }
      $mailer_id = $mailer_temp['Mailer_ID'];
      //     
      $this->_mailer[$mailer_id] = $mailer_temp;
    }

    return $this->get($mailer_id, $item);

  }

  /**
   *        
   * @param int $mailer_id  
   * @param <string $item  
   * @return mixed     
   */
  public function get ( $mailer_id, $item = '' ) {
    //   
    $mailer_id = intval($mailer_id);
    if ( !$mailer_id ) {
      throw new  ExceptionParam( __CLASS__.'::'.__FUNCTION__, 'mailer_id');
    }

    //       -     
    if ( empty($this->_mailer[$mailer_id]) ) {
      $this->db->last_error = '';
      $this->_mailer[$mailer_id] = $this->db->get_row("SELECT * FROM `Subscriber_Mailer`
                        WHERE `Mailer_ID` = '".$mailer_id."'", ARRAY_A);
      if ( $this->db->last_error ) {
        throw new ExceptionDB(__CLASS__.'::'.__FUNCTION__);
      }
    }

    //   
    if ( empty($this->_mailer[$mailer_id]) ) {
      throw new ExceptionMailer();
    }
    //  
    if ( $item ) return $this->_mailer[$mailer_id][$item];
    return $this->_mailer[$mailer_id];
  }

  /**
   *    
   * @param mixed $mailer_ids      
   * @return int   
   */
  public function activate ( $mailer_ids) {
    return $this->change_status ($mailer_ids, 1 );
  }

  /**
   *    
   * @param mixed $mailer_ids      
   * @return int   
   */
  public function unactivate ( $mailer_ids ) {
    return $this->change_status ($mailer_ids, 0 );
  }

  /**
   *     
   *      Active    
   * @param mixed $mailer_ids      
   * @param bool $activ/ true -  . false - 
   * @return int   
   */
  public function change_status ( $mailer_ids, $activ ) {
    if ( !is_array($mailer_ids) ) $mailer_ids = array($mailer_ids);
    if ( empty($mailer_ids) ) return 0;
    foreach ( $mailer_ids as $k => $mailer_id ) {
      $mailer_ids[$k] = intval($mailer_id);
    }
    $mailer_ids = array_unique($mailer_ids);
    
    $activ = $activ ? 1 : 0;
    
    $this->db->last_error = '';
    $this->db->rows_affected = 0;
    
    $this->db->query("UPDATE `Subscriber_Mailer` SET `Active` ='".$activ."'
                      WHERE `Mailer_ID` IN (".join(', ', $mailer_ids).") ");
    if ( $this->db->last_error ) {
      throw new ExceptionDB(__CLASS__.'::'.__FUNCTION__);
    }
    
    return $this->db->rows_affected ;
  }

  /**
   *    .
   *          
   * @param mixed $mailer_ids      
   * @return c  
   */
  public function delete ( $mailer_ids ) {
    if ( !is_array($mailer_ids) ) $mailer_ids = array($mailer_ids);
    if ( empty($mailer_ids) ) return 0;
    foreach ( $mailer_ids as $k => $mailer_id ) {
      $mailer_ids[$k] = intval($mailer_id);
    }
    $mailer_ids = array_unique($mailer_ids);
    $this->db->last_error = '';

    $this->db->query("DELETE FROM  `Subscriber_Subscription`  WHERE `Mailer_ID` IN (".join(', ', $mailer_ids).") ");
    $this->db->query("DELETE FROM  `Subscriber_Log`  WHERE `Mailer_ID` IN (".join(', ', $mailer_ids).") ");
    $this->db->query("DELETE FROM  `Subscriber_UserMessage`  WHERE `Mailer_ID` IN (".join(', ', $mailer_ids).") ");
    $this->db->query("DELETE FROM  `Permission`  WHERE `Catalogue_ID` IN (".join(', ', $mailer_ids).") AND `AdminType` = '".SUBSCRIBER."'");
    $this->db->query("DELETE FROM  `Subscriber_Mailer`  WHERE `Mailer_ID` IN (".join(', ', $mailer_ids).") ");

    if ( $this->db->last_error ) {
      throw new ExceptionDB(__CLASS__.'::'.__FUNCTION__);
    }
    // + 
    return $this->db->rows_affected;
    
    
  }



  public function add ( $params ) {
    $keys = array('Name', 'Type', 'Sub_Class_ID', 'Active', 'Access',
                  'InStat', 'Period', 'SubscribeCond', 'SendCond', 'ActionType', 'SubscribeAction',
                   'Header', 'Footer', 'Record', 'Subject', 'HTML');
    $params['Name'] = $this->db->escape($params['Name']);
    $params['SubscribeCond'] = $this->db->escape($params['SubscribeCond']);
    $params['SendCond'] = $this->db->escape($params['SendCond']);
    $params['SubscribeAction'] = $this->db->escape($params['SubscribeAction']);
    $params['Header'] = $this->db->escape($params['Header']);
    $params['Footer'] = $this->db->escape($params['Footer']);
    $params['Record'] = $this->db->escape($params['Record']);
    $params['Subject'] = $this->db->escape($params['Subject']);

    $params['Type'] = (isset($params['Type']) && in_array($params['Type'], array(1,2,3) ))? intval($params['Type']) : 1;
    $params['Access'] = (isset($params['Access']) && in_array($params['Access'], array(1,2,3) ))? intval($params['Access']) : 1;
    $params['Active'] = isset($params['Active']) ? intval($params['Active']) : 1;
    $params['Sub_Class_ID'] = intval($params['Sub_Class_ID']);
    $params['InStat'] = intval($params['InStat']);
    $params['Period'] = intval($params['Period']);
    $params['ActionType'] = intval($params['ActionType']);
    $params['HTML'] = intval($params['HTML']);

    //       
    if ( $type == 1 ) {
      $this->tools->check_cc($params['Sub_Class_ID']);
    } //   - 
    else {
      //  period
      if ( $params['Period']) {
        $this->tools->check_period($params['Period']);
      }
      else { //   
        $params['Period'] = $this->tools->get_default_period();
      }
    }

    foreach ( $keys as $key ) {
      $query_insert[] = "`".$key."`";
      $query_values[] = "'".$params[$key]."'";
    }

    $this->db->last_error = '';
    $this->db->query("INSERT INTO `Subscriber_Mailer`
                     (".join(', ', $query_insert)." )
                     VALUES (".join(', ', $query_values ).") ");

    if ( $this->db->last_error ) {
      throw new ExceptionDB(__CLASS__.'::'.__FUNCTION__);
    }

    return $this->db->insert_id;
  }


  public function update ( $mailer_id, $params = array () ) {
    $mailer_id = intval($mailer_id);
    //    ,   ,  get  
    $mailer = $this->get($mailer_id);
    //  
    $keys_int = array('Type', 'Sub_Class_ID','Active', 'Access', 'Period',
                      'InStat', 'ActionType', 'HTML' );
    //  
    $keys_text = array('Name', 'SubscribeCond', 'SendCond', 'SubscribeAction',
                       'Header', 'Footer', 'Record', 'Subject');
    //  ->,   
    $values = array();
    foreach ( $keys_int as $key ) {
      if ( isset($params[$key]) ) {
        $values[$key] = intval($params[$key]);
      }
    }
    foreach ( $keys_text as $key ) {
      if ( isset($params[$key]) ) {
         $values[$key] = $this->db->escape($params[$key]);
      }
    }

    if ( empty($values) ) return 0;

    //       ,     "  " - 
    //   
    if ( $values['Type'] == 1 || (!isset($values['Type']) && $mailer['Type'] == 1) )  {
      $this->tools->check_cc( isset($values['Sub_Class_ID'])  ? $values['Sub_Class_ID'] : $mailer['Sub_Class_ID']);
    } //   - 

    if ( $values['Type'] != 1  || (!isset($values['Type']) && $mailer['Type'] != 1) )   {
      if ( $values['Period'] ) {
        $this->tools->check_period($values['Period']);
      }
      else {
        if ( !$mailer['Period']) {
          $values['Period'] = $this->tools->get_default_period();
        }
      }
    }

    $query = "UPDATE `Subscriber_Mailer` SET ";
    foreach ( $values as $key => $value ) {
      $query .= "  `".$key."` = '".$value."', ";
    }
    $query .= "`Mailer_ID` = `Mailer_ID` ";
    $query .= "WHERE `Mailer_ID` = '".$mailer_id."' ";

    $this->db->last_error = '';
    $this->db->query($query);

    if ( $this->db->last_error ) {
      throw new ExceptionDB(__CLASS__.'::'.__FUNCTION__);
    }

    return 1;

  }

  /**
   *        
   * @global array $current_user      
   *
   * @todo     nc_core->users->get_by_id
   * @todo    
   *
   * @param int $mailer_id  
   * @param int $user_id  
   *
   */
  public function send_confirm_mail ($mailer_id, $user_id) {
    //    
    $mailer_id = intval($mailer_id);
    $user_id = intval($user_id);
    if ( !$mailer_id || !$user_id ) {
      throw new ExceptionParam(__CLASS__.'::'.__FUNCTION__);
    }
    global $current_user;
    $this->tools->check_user($user_id);
    //nc_core->users->get_by_id
    //    -       $current_user
    if ( $current_user['User_ID'] == $user_id ) {
      $cur_user = $current_user;   
    }
    else {
      $cur_user = $this->db->get_row("SELECT * FROM `User` WHERE `User_ID` = '".$user_id."'", ARRAY_A);
    }

    //     
    $mail_subject = $this->tools->get_settings('ConfirmSubject');
    $mail_body = $this->tools->get_settings('ConfirmBody');
    $is_html = $this->tools->get_settings('ConfirmHTML');
    //  
    $mail_body = $this->replace_macrovariables($mail_body, $cur_user, $mailer_id);
    $mail_subject = $this->replace_macrovariables($mail_subject, $cur_user, $mailer_id);
    // 
    $nc_send = nc_subscriber_send::get_object();
    $nc_send->send_mail ( $cur_user[$this->tools->get_settings('EmailField')], $mail_body, $mail_subject, $is_html);

    return 0;

  }

  /**
   *      .
   *      ()  .
   *   /  
   *
   * @param array $ids / 
   * @return <type>
   */
  public function subscription_confirm ( $ids ) {
    if ( !is_array($ids)) $ids = array($ids);
    if ( empty( $ids) ) return false;

    foreach ( $ids as $k => $v){
      $ids[$k] = intval($v);
    }

    $this->db->last_error = '';
    //   
    $users_id =  $this->db->get_col("SELECT `User_ID` 
                                     FROM`Subscriber_Subscription` 
                                     WHERE `ID` IN (".join(', ', $ids).") ");
    if ( empty($users_id ) ) return 0;
    //     
    $this->db->query("UPDATE `Subscriber_Subscription`
                      SET `Status` = 'on', `Hash` = CONCAT(`Hash`, 'delete')
                      WHERE `User_ID` IN (".join(', ', $users_id).")
                      AND `Status` = 'wait'");
    //        id 
    $res = $this->db->get_results("SELECT `Mailer_ID`, `User_ID`
                             FROM `Subscriber_Subscription`
                             WHERE  `ID` IN (".join(', ', $ids).") ", ARRAY_A); 

    if ( $this->db->last_error ) {
      throw new ExceptionDB(__CLASS__.'::'.__FUNCTION__);
    }

    if ( empty ($res) ) {
      return false;
    }
    foreach ( $res as $v) {
      $this->tools->log( $v['Mailer_ID'], $v['User_ID'], 'confirm');
    }


  }

  /**
   *   
   * @param mixed $ids  
   * @return int   
   */
  public function subscription_delete ( $ids ) {
    if ( !is_array($ids)) $ids = array($ids);
    if ( empty( $ids) ) return false;

    foreach ( $ids as $k => $v){
      $ids[$k] = intval($v);
    }

    //      
    $res = $this->db->get_results("SELECT `Mailer_ID`, `User_ID`
                             FROM `Subscriber_Subscription`
                             WHERE  `ID` IN (".join(', ', $ids).") ", ARRAY_A);  

    if ( !empty ($res) ) {
      foreach ( $res as $v) {
        $this->tools->log( $v['Mailer_ID'], $v['User_ID'], 'unsubscribe');
        $this->db->query("DELETE FROM `Subscriber_UserMessage` WHERE `User_ID` = '".$v['User_ID']."' AND `Mailer_ID` = '".$v['Mailer_ID']."'");
      }
    }

    $this->db->query("DELETE FROM `Subscriber_Subscription`  WHERE `ID` IN (".join(', ', $ids).") ");

    return $this->db->rows_affected;
    
  }


  /**
   *    
   * @global int $AUTH_USER_ID
   * @param mixed $mailer_ids / 
   * @param int $user_id  
   * @return   
   */
  public function subscription_delete_by_mailer ( $mailer_ids, $user_id = 0 ) {
    //     -   
    $user_id = intval($user_id);
    if ( !$user_id) {
      global $AUTH_USER_ID;
      $user_id = $AUTH_USER_ID;
    }

    if ( !is_array($mailer_ids)) $mailer_ids = array($mailer_ids);
    //   ,     
    if ( empty( $mailer_ids) || !$user_id) return false;

    foreach ( $mailer_ids as $k => $v){
      $mailer_ids[$k] = intval($v);
      $this->tools->log( $mailer_ids[$k], $user_id, 'unsubscribe');
    }
    $this->db->query("DELETE FROM `Subscriber_UserMessage` WHERE `Mailer_ID` IN (".join(', ', $mailer_ids).") AND `User_ID` = '".$user_id."'");
    $this->db->query("DELETE FROM `Subscriber_Subscription`  WHERE `Mailer_ID` IN (".join(', ', $mailer_ids).") AND `User_ID` = '".$user_id."'");

    return $this->db->rows_affected;


  }


  /**
   * 
   * @param mixed $subsc_ids / 
   * @param mixed $status true  'on' - , false  'off' - 
   * @return int   
   */
  public function subscription_change_status ( $subsc_ids, $status ) {
    if ( !is_array($subsc_ids) ) $subsc_ids = array($subsc_ids);
    if ( empty($subsc_ids) ) return 0;
    foreach ( $subsc_ids as $k => $subsc_id ) {
      $subsc_ids[$k] = intval($subsc_id);
    }
    $subsc_ids = array_unique($subsc_ids);

    $status = ($status && $status != 'off' ) ? 'on' : 'off';

    $this->db->last_error = '';
    $this->db->rows_affected = 0;

    $this->db->query("UPDATE `Subscriber_Subscription` SET `Status` ='".$status."' WHERE `ID` IN (".join(', ', $subsc_ids).") ");
    if ( $this->db->last_error ) {
      throw new ExceptionDB(__CLASS__.'::'.__FUNCTION__);
    }

    return $this->db->rows_affected ;
  }

  /**
   *     
   * @param int $sbs_id  
   * @param int $period  
   */
  public function subscription_change_period ( $sbs_id, $period ) {
    //   
    $period = intval($period);
    $sbs_id = intval($sbs_id);
    $this->tools->check_period($period);
    // 
    $this->db->query("UPDATE `Subscriber_Subscription` SET `Period` = '".$period."' WHERE `ID` = '".$sbs_id."' ");
  }


  /**
   *        
   * @global int $AUTH_USER_ID
   * @global array $current_user
   * @global object $perm
   * @param int $mailer_id  
   * @return bool. true - , false - 
   */
  public function check_rights ( $mailer_id ) {
    //  
    // 1 - , 2 - , 3 - 
    $access = $this->get($mailer_id, 'Access');
    if ( !$access) return false; 
    switch ( $access ) {
      case 1: // 
        return true;
      case 2: // 
        global $AUTH_USER_ID, $current_user;
        if ( $AUTH_USER_ID && $current_user['UserType'] == 'normal') return true; 
        break;
      case 3: // 
        global $perm;
        if ( is_object($perm) && $perm->isSubscriber($mailer_id) )
          return true;
        break;
      default:
        return false;
    }

    return false;
  }


  public function get_user_subscription ( $user_id = 0 ) {
    //   
    if ( !$user_id ) {
      global $AUTH_USER_ID;
      $user_id = $AUTH_USER_ID;
    }
    $user_id = intval($user_id);
    if ( !$user_id ) return false;
    //     
    if ( isset($this->_subscribers[$user_id]) ) return $this->_subscribers[$user_id];

    //  ,    
    $mailers = $this->db->get_results("SELECT sm.*
                                       FROM `Subscriber_Subscription` AS `ss`,
                                       `Subscriber_Mailer` AS `sm`
                                       WHERE sm.`Mailer_ID` = ss.`Mailer_ID`
                                       AND `User_ID` = '".$user_id."' ", ARRAY_A);
    $this->_subscribers[$user_id] = array();
    if ( !empty($mailers) ) {
      foreach ( $mailers as $v ) {
        // id 
        $id = $v['Mailer_ID'];
        //       
        $this->_mailer[$id] = $v;
        $this->_subscribers[$user_id][] = $id;
      }
    }

    return $this->_subscribers[$user_id];
  }


  public function is_subscribe_to_cc ( $cc, $user_id = 0 ) {
    //  
    $cc = intval($cc);
    if ( !$cc ) return false;
    //    
    $all_subscribers = $this->get_user_subscription($user_id);

    if ( empty($all_subscribers)) return false;
    //   
    foreach ( $all_subscribers as $v ) {
      //  ,    
      $mailer_cc = $this->get( $v, 'Sub_Class_ID');
      if ( $cc == $mailer_cc ) return true;
    }

    return false;
  }


  public function is_subscribe_to_message ( $cc, $message, $user_id = 0) {
    static $storage, $init;
    //  
    $cc = intval($cc);
    $message = intval($message);
    $user_id =intval($user_id);

    if ( !$user_id ) {
      global $AUTH_USER_ID;
      $user_id = $AUTH_USER_ID;
    }

    if ( !$cc || !$message || !$user_id ) {
      return false;
    }

    //      -    
    if ( !$init ) {
      $init = 1;
      $storage = $this->db->get_results("SELECT `Sub_Class_ID`, `Message_ID`
                                         FROM `Subscriber_UserMessage`
                                         WHERE `User_ID` = '".$user_id."'", ARRAY_A);
    }
    //   
    if ( !empty($storage) ) {
      foreach ( $storage as $v ) {
        if ( $cc == $v['Sub_Class_ID'] && $message == $v['Message_ID'])
          return true;
      }
    }
    //     -     
    return false;

  }
  /**
   *        
   * @param string $text  
   * @param array $current_user     
   * @param int $mailer_id  
   * @return string 
   */
  public function replace_macrovariables ( $text, $current_user, $mailer_id) {
    //   -  / 
    static $links = array();
    if ( empty($links) ) {
      $res = $this->db->get_results("SELECT `User_ID`, `Mailer_ID`, `Hash` FROM `Subscriber_Subscription`", ARRAY_A);
      if ( !empty($res) ) {
        foreach ( $res as $v ) {
          $links[$v['User_ID']][$v['Mailer_ID']] = $v['Hash'];
        }
      }      
    }
    // ,     
    $con_sub = $this->tools->get_subscribe_sub();
    //  
    $text = str_replace('%USER_LOGIN%', $current_user['Login'], $text);
    $text = str_replace('%LINK%', "http://".$con_sub['Domain'].$this->core->SUB_FOLDER.$this->core->HTTP_ROOT_PATH."modules/subscriber/confirm.php?hash=".$links[$current_user['User_ID']][$mailer_id], $text);
    $text = str_replace('%SUB_LINK%', "http://".$con_sub['Domain'].$con_sub['Hidden_URL'].( $current_user['UserType'] == 'pseudo' ? '?auth_hash='.$current_user['Auth_Hash'] : ''), $text );
    return $text;
  }


  public function delete_expire () {
    //      
    $expire_time = $this->tools->get_settings('MaxTime')*60*60;
    $sbs_to_delete = $this->db->get_results("SELECT ss.`ID`, u.`User_ID`, u.`UserType`
                                             FROM `Subscriber_Subscription` AS `ss`, 
                                                  `User` AS `u` 
                                             WHERE u.`User_ID` = ss.`User_ID`
                                             AND `Status` = 'wait'
                                            AND (UNIX_TIMESTAMP() - UNIX_TIMESTAMP(ss.`Created`)) >= '".$expire_time."' ", ARRAY_A);
    //   
    if ( !empty($sbs_to_delete) ) {
      $c_sub = $this->tools->get_subscribe_sub('Subdivision_ID');
      foreach ( $sbs_to_delete as $v ) {
        $ids[] = $v['ID'];
        if ( $v['UserType'] == 'pseudo' && $this->core->modules->get_by_keyword('auth') ) {
          $nc_auth = nc_auth::get_object();
          $nc_auth->hash->delete_from_sub($c_sub , $v['User_ID']);
        }
      }

      $this->db->query("DELETE FROM `Subscriber_Subscription`  WHERE `ID` IN (".join(', ', $ids).") ");
    }

    //     Subscribe_Message
    //   Value - . MAX(`Value`)    
    $all_period =  $this->db->get_col("SELECT `Value` FROM `Classificator_".$this->period_table."` ");
    $expire_time = 0;
    if ( !empty($all_period) )  $expire_time = max($all_period);

    $this->db->query("DELETE FROM `Subscriber_Message`
                      WHERE (UNIX_TIMESTAMP() - UNIX_TIMESTAMP(`Date`)) >= '".$expire_time."' ");


    return 0;
  }
}


class ExceptionParam extends Exception {
  function __construct ($a, $param = '') {
    parent::__construct('Incorrect param '.( $param ? $param : '').' in  '.$a);
  }
};

class ExceptionDB extends Exception {
  function  __construct($a) {
    global $db, $perm;
    if ( is_object($perm) && $perm->isSupervisor() || $cron) {
      $m =  "SQL error:<br/>".$db->last_error."<br/>Query:<br/>".$db->last_query."<br/>in ".$a."<br/>";
    }
    else {
      $m = "SQL error";
    }
    parent::__construct($m);
  }
};

class ExceptionEmail extends Exception {
  function __construct () {
    parent::__construct();
  }
};

class ExceptionMailer extends Exception {
  function __construct () {
    parent::__construct(NETCAT_MODULE_SUBSCRIBER_MAILER_DOES_NOT_EXIST);
  }
}

?>
