<?php
/* $Id: s_loadenv.inc.php 3828 2010-06-18 14:20:40Z denis $ */



function ListClassVars ($cc, $user_table_mode, $nc_ctpl = 0) {
  global $db, $perm;
  global $MODULE_VARS, $DOMAIN_NAME;
  global $cc_in_sub, $nc_core;
  
  $nc_ctpl = intval($nc_ctpl);
  
  // cache section
  if ( $nc_core->modules->get_by_keyword("cache") ) {
    try {
      $nc_cache_function = nc_cache_function::getObject();
      $cc_data = $db->get_row("SELECT `Catalogue_ID`, `Subdivision_ID`, `Sub_Class_ID`
        FROM `Sub_Class` WHERE `Sub_Class_ID` = '".intval($cc)."'", ARRAY_A);
      // make uniqe string concat parameters for this function
      $data_string = $user_table_mode."-".serialize($MODULE_VARS['auth'])."-".$DOMAIN_NAME."-".$nc_ctpl;
      // check cached data
      $cached_data = $nc_cache_function->read($cc_data, $data_string, $MODULE_VARS['cache']['DEFAULT_LIFETIME']);
      if ($cached_data!=-1) {
        // debug info
        $cache_debug_info = "Readed, catalogue[".$cc_data['Catalogue_ID']."], sub[".$cc_data['Subdivision_ID']."], cc[".$cc_data['Sub_Class_ID']."], Access_ID[-], Lifetime[-], bytes[".strlen($cached_data)."]";
        $nc_cache_function->debugMessage($cache_debug_info, __FILE__, __LINE__);
        // return cache if not eval flag setted
        $Array = unserialize($cached_data);
        return $Array;
      }
    }
    catch (Exception $e) {
      // for debug
      $nc_cache_function->errorMessage($e);
    }
  }
  
  if (!$user_table_mode) {
    $Array = array();

    if ($cc_in_sub) {
      foreach ($cc_in_sub as $row) {
        if ($row["Sub_Class_ID"]==$cc) {
          $Array = $row;
          break;
        }
      }
    }

    if ( empty($Array) ) {
      $Array = $db->get_row("SELECT * FROM `Sub_Class` WHERE `Sub_Class_ID` = '".intval($cc)."'", ARRAY_A);
    }
    
    if ($nc_ctpl) {
      $class_cond = "`Class_ID` = '".$nc_ctpl."'";
    }
    else {
      // use class template or not?
      $class_cond = "`Class_ID` = '".($Array["Class_Template_ID"] ? $Array["Class_Template_ID"] : $Array["Class_ID"])."'";
    }
  }
  else {
    $user_table_id = $db->get_var("SELECT `System_Table_ID` FROM `System_Table` WHERE `System_Table_Name` = 'User'");
    $class_cond = "`System_Table_ID` = '".$user_table_id."'";
    $Array["System_Table_ID"] = $user_table_id;
    $Array["Subdivision_ID"] = $MODULE_VARS['auth']['USER_LIST_SUB'];
    $Array["EnglishName"] = $MODULE_VARS['auth']['USER_KEYWORD'];
  }


  //  ,  $cc  
  if (!$Array) {
    // error message
    if ( is_object($perm) &&  $perm->isSupervisor() ) {
      // backtrace info
      $debug_backtrace_info = debug_backtrace();
      // choose error
      if ( isset($debug_backtrace_info[1]['function']) && $debug_backtrace_info[1]['function']=="nc_objects_list" ) {
        // error info for the supervisor
        trigger_error( sprintf( NETCAT_FUNCTION_OBJECTS_LIST_CC_ERROR, $cc), E_USER_WARNING );
      }
      else {
        // error info for the supervisor
        trigger_error( sprintf( NETCAT_FUNCTION_LISTCLASSVARS_ERROR_SUPERVISOR, $cc), E_USER_WARNING );
      }
    }
    return NULL;
  }

  // inherit from Class
  $class_env = $db->get_row("SELECT * FROM `Class` WHERE ".$class_cond, ARRAY_A);

  if ($class_env['CustomSettingsTemplate']) {
    require_once ($GLOBALS['ADMIN_FOLDER']."array_to_form.inc.php");
    $a2f = new nc_a2f($class_env['CustomSettingsTemplate'], $Array['CustomSettings'], 'CustomSettings');
    $Array["Sub_Class_Settings"] = $a2f->get_values_as_array();
  }

  foreach ($class_env AS $key => $val) {
    if ($Array[$key]=="") $Array[$key] = $val;
  }

  if ($Array["NL2BR"] == -1) $Array["NL2BR"] = $class_env["NL2BR"];
  if ($Array["AllowTags"] == -1) $Array["AllowTags"] = $class_env["AllowTags"];
  if ( $nc_core->modules->get_by_keyword("cache") ) {
    if ($Array["CacheForUser"] == -1) $Array["CacheForUser"] = $class_env["CacheForUser"];
  }

  if ($Array["Subdivision_ID"]) {
    $parent_sub = $Array["Subdivision_ID"];
    $Domain = $db->get_var("SELECT Catalogue.Domain FROM `Catalogue`
      LEFT JOIN `Subdivision` ON Subdivision.Catalogue_ID = Catalogue.Catalogue_ID
      WHERE Subdivision.Subdivision_ID = '".$parent_sub."'");
    $HiddenHost = $Domain ? ( strchr($Domain,".") ? $Domain : $Domain.".".$DOMAIN_NAME ) : $DOMAIN_NAME;

    while ($parent_sub) {
      $ParentArray = GetSubdivisionByID($parent_sub);
      
      if ($Array["Subdivision_ID"]==$parent_sub) {
        $Array["Subdivision_Name"] = $ParentArray["Subdivision_Name"];
        $Array["Hidden_URL"] = $ParentArray["Hidden_URL"];
        $Array["Hidden_Host"] = $HiddenHost;
      }

      if (!$Array["Read_Access_ID"]) $Array["Read_Access_ID"] = $ParentArray["Read_Access_ID"];
      if (!$Array["Write_Access_ID"]) $Array["Write_Access_ID"] = $ParentArray["Write_Access_ID"];
      if (!$Array["Edit_Access_ID"]) $Array["Edit_Access_ID"] = $ParentArray["Edit_Access_ID"];
      if (!$Array["Subscribe_Access_ID"]) $Array["Subscribe_Access_ID"] = $ParentArray["Subscribe_Access_ID"];
      if ( $nc_core->modules->get_by_keyword("cache") ) {
        if (!$Array["Cache_Access_ID"]) $Array["Cache_Access_ID"] = $ParentArray["Cache_Access_ID"];
        if (!$Array["Cache_Lifetime"]) $Array["Cache_Lifetime"] = $ParentArray["Cache_Lifetime"];
      }
      if (!$Array["Moderation_ID"]) $Array["Moderation_ID"] = $ParentArray["Moderation_ID"];

      $parent_sub = $ParentArray["Parent_Sub_ID"];
    }

    if (!$Array["Catalogue_ID"]) $Array["Catalogue_ID"] = $ParentArray["Catalogue_ID"];
  }

  if ($Array["Catalogue_ID"]==$GLOBALS["catalogue"]) {
    $ParentArray = $GLOBALS["current_catalogue"];
  }
  else {
    $ParentArray = $db->get_row("SELECT * FROM `Catalogue` WHERE `Catalogue_ID` = '".$Array["Catalogue_ID"]."'", ARRAY_A);
  }

  if (!$Array["Read_Access_ID"]) $Array["Read_Access_ID"] = $ParentArray["Read_Access_ID"];
  if (!$Array["Write_Access_ID"]) $Array["Write_Access_ID"] = $ParentArray["Write_Access_ID"];
  if (!$Array["Edit_Access_ID"]) $Array["Edit_Access_ID"] = $ParentArray["Edit_Access_ID"];
  if (!$Array["Subscribe_Access_ID"]) $Array["Subscribe_Access_ID"] = $ParentArray["Subscribe_Access_ID"];
  if ( $nc_core->modules->get_by_keyword("cache") ) {
    if (!$Array["Cache_Access_ID"]) $Array["Cache_Access_ID"] = $ParentArray["Cache_Access_ID"];
    if (!$Array["Cache_Lifetime"]) $Array["Cache_Lifetime"] = $ParentArray["Cache_Lifetime"];
  }
  if (!$Array["Moderation_ID"]) $Array["Moderation_ID"] = $ParentArray["Moderation_ID"];
  
  // cache section
  if ( $nc_core->modules->get_by_keyword("cache") && $Array['Cache_Access_ID']==1 && is_object($nc_cache_function) ) {
    try {
      $bytes = $nc_cache_function->add($Array, $data_string, serialize($Array) );
      // debug info
      if ($bytes) {
        $cache_debug_info = "Writed, catalogue[".$Array['Catalogue_ID']."], sub[".$Array['Subdivision_ID']."], cc[".$Array['Sub_Class_ID']."], Access_ID[-], Lifetime[-], bytes[".$bytes."]";
        $nc_cache_function->debugMessage($cache_debug_info, __FILE__, __LINE__, "ok");
      }
    }
    catch (Exception $e) {
      // for debug
      $nc_cache_function->errorMessage($e);
    }
  }
  
  return $Array;
}



function LoadSystemTableClass ($SystemTableName) {
  global $db;

  $table_env = $db->get_row("SELECT * FROM `System_Table` AS a, `Class` AS b WHERE a.`System_Table_ID` = b.`System_Table_ID` AND a.`System_Table_Name` = '".$SystemTableName."'", ARRAY_A);

  return $table_env;
}

###########################
### THIS FUNCTION IS DEPRECATED ###
###########################
function LoadSystemSettings () {
  global $db, $system_env;

  $system_env = $db->get_row("SELECT settings.*, field.`Field_Name` AS UserEmail FROM `Settings` AS settings LEFT JOIN `Field` AS field ON settings.`UserEmailField` = field.`Field_ID` ORDER BY `Settings_ID` LIMIT 1", ARRAY_A);

  Header("X-Powered-By: ".$system_env['Powered']);

  return;
}


###########################
### THIS FUNCTION IS DEPRECATED ###
###########################
function GetCatalougeLanguge($catid = 0) {
  global $db, $catalogue, $current_catalogue;
  
  if (!$catalogue) $catalogue = $catid;

  // return current catalogue language
  if (is_array($current_catalogue) && ($current_catalogue["Catalogue_ID"]==$catid || $catid===0)) {
    return $current_catalogue["Language"];
  }

  $res = $db->get_var("SELECT `Language` FROM `Catalogue` WHERE `Catalogue_ID` = '".intval($catalogue)."' LIMIT 1");

  if ($res) {
    return($res);
  }
  else {
    return(false);
  }
}




?>
